'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var $fetch = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(url) {
    var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var result, handle;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            result = myFetch(url, option);
            handle = opts.filter(result);
            return _context2.abrupt('return', handle ? handle : result);

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function $fetch(_x3) {
    return _ref2.apply(this, arguments);
  };
}();

var $get = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(url) {
    var getOpts, result, handle;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            getOpts = (0, _assign2.default)({
              method: 'GET'
            }, opts);
            _context3.next = 3;
            return myFetch(url + '?t=' + +new Date(), getOpts);

          case 3:
            result = _context3.sent;
            handle = opts.filter(result);
            return _context3.abrupt('return', handle ? handle : result);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function $get(_x5) {
    return _ref3.apply(this, arguments);
  };
}();

var $post = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(url, data) {
    var postOpts, result, handle;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            postOpts = (0, _assign2.default)({
              method: 'POST'
            }, opts);

            if (data) {
              postOpts.body = (0, _stringify2.default)(data);
            }
            _context4.next = 4;
            return myFetch(url, postOpts);

          case 4:
            result = _context4.sent;
            handle = opts.filter(result);
            return _context4.abrupt('return', handle ? handle : result);

          case 7:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function $post(_x6, _x7) {
    return _ref4.apply(this, arguments);
  };
}();

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var opts = {};

function myFetch(url, opt) {
  var _this = this;

  return new _promise2.default(function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(resolve, reject) {
      var result;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return (0, _isomorphicFetch2.default)(url, opt);

            case 3:
              result = _context.sent;

              resolve(result.json());
              _context.next = 10;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context['catch'](0);

              reject(_context.t0);

            case 10:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[0, 7]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
}

exports.default = {
  fetch: $fetch,
  get: $get,
  post: $post,
  install: function install(Vue, options) {
    (0, _assign2.default)(opts, options);
    Vue.mixin({
      methods: {
        $fetch: $fetch,
        $get: $get,
        $post: $post
      }
    });
  }
};